﻿//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;
using Object = UnityEngine.Object;
#if UNITY_EDITOR
public class UnityEditor_AssetDatabaseWrap
{
	public static void Register(LuaState L)
	{
		L.BeginClass(typeof(UnityEditor.AssetDatabase), typeof(System.Object));
		L.RegFunction("CanOpenForEdit", CanOpenForEdit);
		L.RegFunction("IsOpenForEdit", IsOpenForEdit);
		L.RegFunction("MakeEditable", MakeEditable);
		L.RegFunction("FindAssets", FindAssets);
		L.RegFunction("Contains", Contains);
		L.RegFunction("CreateFolder", CreateFolder);
		L.RegFunction("IsMainAsset", IsMainAsset);
		L.RegFunction("IsSubAsset", IsSubAsset);
		L.RegFunction("IsForeignAsset", IsForeignAsset);
		L.RegFunction("IsNativeAsset", IsNativeAsset);
		L.RegFunction("GetCurrentCacheServerIp", GetCurrentCacheServerIp);
		L.RegFunction("GenerateUniqueAssetPath", GenerateUniqueAssetPath);
		L.RegFunction("StartAssetEditing", StartAssetEditing);
		L.RegFunction("StopAssetEditing", StopAssetEditing);
		L.RegFunction("ReleaseCachedFileHandles", ReleaseCachedFileHandles);
		L.RegFunction("ValidateMoveAsset", ValidateMoveAsset);
		L.RegFunction("MoveAsset", MoveAsset);
		L.RegFunction("ExtractAsset", ExtractAsset);
		L.RegFunction("RenameAsset", RenameAsset);
		L.RegFunction("MoveAssetToTrash", MoveAssetToTrash);
		L.RegFunction("MoveAssetsToTrash", MoveAssetsToTrash);
		L.RegFunction("DeleteAsset", DeleteAsset);
		L.RegFunction("DeleteAssets", DeleteAssets);
		L.RegFunction("ImportAsset", ImportAsset);
		L.RegFunction("CopyAsset", CopyAsset);
		L.RegFunction("WriteImportSettingsIfDirty", WriteImportSettingsIfDirty);
		L.RegFunction("GetSubFolders", GetSubFolders);
		L.RegFunction("IsValidFolder", IsValidFolder);
		L.RegFunction("CreateAsset", CreateAsset);
		L.RegFunction("AddObjectToAsset", AddObjectToAsset);
		L.RegFunction("SetMainObject", SetMainObject);
		L.RegFunction("GetAssetPath", GetAssetPath);
		L.RegFunction("GetAssetOrScenePath", GetAssetOrScenePath);
		L.RegFunction("GetTextMetaFilePathFromAssetPath", GetTextMetaFilePathFromAssetPath);
		L.RegFunction("GetAssetPathFromTextMetaFilePath", GetAssetPathFromTextMetaFilePath);
		L.RegFunction("LoadAssetAtPath", LoadAssetAtPath);
		L.RegFunction("LoadMainAssetAtPath", LoadMainAssetAtPath);
		L.RegFunction("GetMainAssetTypeAtPath", GetMainAssetTypeAtPath);
		L.RegFunction("GetTypeFromPathAndFileID", GetTypeFromPathAndFileID);
		L.RegFunction("IsMainAssetAtPathLoaded", IsMainAssetAtPathLoaded);
		L.RegFunction("LoadAllAssetRepresentationsAtPath", LoadAllAssetRepresentationsAtPath);
		L.RegFunction("LoadAllAssetsAtPath", LoadAllAssetsAtPath);
		L.RegFunction("GetAllAssetPaths", GetAllAssetPaths);
		L.RegFunction("Refresh", Refresh);
		L.RegFunction("OpenAsset", OpenAsset);
		L.RegFunction("GUIDToAssetPath", GUIDToAssetPath);
		L.RegFunction("GUIDFromAssetPath", GUIDFromAssetPath);
		L.RegFunction("AssetPathToGUID", AssetPathToGUID);
		L.RegFunction("GetAssetDependencyHash", GetAssetDependencyHash);
		L.RegFunction("SaveAssets", SaveAssets);
		L.RegFunction("GetCachedIcon", GetCachedIcon);
		L.RegFunction("SetLabels", SetLabels);
		L.RegFunction("GetLabels", GetLabels);
		L.RegFunction("ClearLabels", ClearLabels);
		L.RegFunction("GetAllAssetBundleNames", GetAllAssetBundleNames);
		L.RegFunction("GetUnusedAssetBundleNames", GetUnusedAssetBundleNames);
		L.RegFunction("RemoveAssetBundleName", RemoveAssetBundleName);
		L.RegFunction("RemoveUnusedAssetBundleNames", RemoveUnusedAssetBundleNames);
		L.RegFunction("GetAssetPathsFromAssetBundle", GetAssetPathsFromAssetBundle);
		L.RegFunction("GetAssetPathsFromAssetBundleAndAssetName", GetAssetPathsFromAssetBundleAndAssetName);
		L.RegFunction("GetImplicitAssetBundleName", GetImplicitAssetBundleName);
		L.RegFunction("GetImplicitAssetBundleVariantName", GetImplicitAssetBundleVariantName);
		L.RegFunction("GetAssetBundleDependencies", GetAssetBundleDependencies);
		L.RegFunction("GetDependencies", GetDependencies);
		L.RegFunction("ExportPackage", ExportPackage);
		L.RegFunction("IsMetaFileOpenForEdit", IsMetaFileOpenForEdit);
		L.RegFunction("GetBuiltinExtraResource", GetBuiltinExtraResource);
		L.RegFunction("ForceReserializeAssets", ForceReserializeAssets);
		L.RegFunction("TryGetGUIDAndLocalFileIdentifier", TryGetGUIDAndLocalFileIdentifier);
		L.RegFunction("RemoveObjectFromAsset", RemoveObjectFromAsset);
		L.RegFunction("ImportPackage", ImportPackage);
		L.RegFunction("DisallowAutoRefresh", DisallowAutoRefresh);
		L.RegFunction("AllowAutoRefresh", AllowAutoRefresh);
		L.RegFunction("ClearImporterOverride", ClearImporterOverride);
		L.RegFunction("IsCacheServerEnabled", IsCacheServerEnabled);
		L.RegFunction("GetImporterOverride", GetImporterOverride);
		L.RegFunction("GetAvailableImporterTypes", GetAvailableImporterTypes);
		L.RegFunction("CanConnectToCacheServer", CanConnectToCacheServer);
		L.RegFunction("RefreshSettings", RefreshSettings);
		L.RegFunction("IsConnectedToCacheServer", IsConnectedToCacheServer);
		L.RegFunction("ResetCacheServerReconnectTimer", ResetCacheServerReconnectTimer);
		L.RegFunction("CloseCacheServerConnection", CloseCacheServerConnection);
		L.RegFunction("GetCacheServerAddress", GetCacheServerAddress);
		L.RegFunction("GetCacheServerPort", GetCacheServerPort);
		L.RegFunction("GetCacheServerNamespacePrefix", GetCacheServerNamespacePrefix);
		L.RegFunction("GetCacheServerEnableDownload", GetCacheServerEnableDownload);
		L.RegFunction("GetCacheServerEnableUpload", GetCacheServerEnableUpload);
		L.RegFunction("IsDirectoryMonitoringEnabled", IsDirectoryMonitoringEnabled);
		L.RegFunction("RegisterCustomDependency", RegisterCustomDependency);
		L.RegFunction("UnregisterCustomDependencyPrefixFilter", UnregisterCustomDependencyPrefixFilter);
		L.RegFunction("IsAssetImportWorkerProcess", IsAssetImportWorkerProcess);
		L.RegFunction("New", _CreateUnityEditor_AssetDatabase);
		L.RegFunction("__tostring", ToLua.op_ToString);
		L.RegVar("onImportPackageItemsCompleted", get_onImportPackageItemsCompleted, set_onImportPackageItemsCompleted);
		L.RegVar("GlobalArtifactDependencyVersion", get_GlobalArtifactDependencyVersion, null);
		L.RegVar("GlobalArtifactProcessedVersion", get_GlobalArtifactProcessedVersion, null);
		L.RegVar("importPackageStarted", get_importPackageStarted, set_importPackageStarted);
		L.RegVar("importPackageCompleted", get_importPackageCompleted, set_importPackageCompleted);
		L.RegVar("importPackageCancelled", get_importPackageCancelled, set_importPackageCancelled);
		L.RegVar("importPackageFailed", get_importPackageFailed, set_importPackageFailed);
		L.RegVar("cacheServerConnectionChanged", get_cacheServerConnectionChanged, set_cacheServerConnectionChanged);
		L.RegFunction("ImportPackageFailedCallback", UnityEditor_AssetDatabase_ImportPackageFailedCallback);
		L.RegFunction("ImportPackageCallback", UnityEditor_AssetDatabase_ImportPackageCallback);
		L.EndClass();
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int _CreateUnityEditor_AssetDatabase(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 0)
			{
				UnityEditor.AssetDatabase obj = new UnityEditor.AssetDatabase();
				ToLua.PushSealed(L, obj);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to ctor method: UnityEditor.AssetDatabase.New");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int CanOpenForEdit(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string[], System.Collections.Generic.List<string>>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				System.Collections.Generic.List<string> arg1 = (System.Collections.Generic.List<string>)ToLua.ToObject(L, 2);
				UnityEditor.AssetDatabase.CanOpenForEdit(arg0, arg1);
				return 0;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEngine.Object, UnityEditor.StatusQueryOptions>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				UnityEditor.StatusQueryOptions arg1 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 2);
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string, UnityEditor.StatusQueryOptions>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				UnityEditor.StatusQueryOptions arg1 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 2);
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEngine.Object, LuaInterface.LuaOut<string>>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string arg1 = null;
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0, out arg1);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string, LuaInterface.LuaOut<string>>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string arg1 = null;
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0, out arg1);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 3 && TypeChecker.CheckTypes<string[], System.Collections.Generic.List<string>, UnityEditor.StatusQueryOptions>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				System.Collections.Generic.List<string> arg1 = (System.Collections.Generic.List<string>)ToLua.ToObject(L, 2);
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 3);
				UnityEditor.AssetDatabase.CanOpenForEdit(arg0, arg1, arg2);
				return 0;
			}
			else if (count == 3 && TypeChecker.CheckTypes<UnityEngine.Object, LuaInterface.LuaOut<string>, UnityEditor.StatusQueryOptions>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string arg1 = null;
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 3);
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0, out arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 3 && TypeChecker.CheckTypes<string, LuaInterface.LuaOut<string>, UnityEditor.StatusQueryOptions>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string arg1 = null;
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 3);
				bool o = UnityEditor.AssetDatabase.CanOpenForEdit(arg0, out arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.CanOpenForEdit");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsOpenForEdit(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string[], System.Collections.Generic.List<string>>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				System.Collections.Generic.List<string> arg1 = (System.Collections.Generic.List<string>)ToLua.ToObject(L, 2);
				UnityEditor.AssetDatabase.IsOpenForEdit(arg0, arg1);
				return 0;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEngine.Object, UnityEditor.StatusQueryOptions>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				UnityEditor.StatusQueryOptions arg1 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 2);
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string, UnityEditor.StatusQueryOptions>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				UnityEditor.StatusQueryOptions arg1 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 2);
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEngine.Object, LuaInterface.LuaOut<string>>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string arg1 = null;
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0, out arg1);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string, LuaInterface.LuaOut<string>>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string arg1 = null;
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0, out arg1);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 3 && TypeChecker.CheckTypes<string[], System.Collections.Generic.List<string>, UnityEditor.StatusQueryOptions>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				System.Collections.Generic.List<string> arg1 = (System.Collections.Generic.List<string>)ToLua.ToObject(L, 2);
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 3);
				UnityEditor.AssetDatabase.IsOpenForEdit(arg0, arg1, arg2);
				return 0;
			}
			else if (count == 3 && TypeChecker.CheckTypes<UnityEngine.Object, LuaInterface.LuaOut<string>, UnityEditor.StatusQueryOptions>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string arg1 = null;
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 3);
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0, out arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 3 && TypeChecker.CheckTypes<string, LuaInterface.LuaOut<string>, UnityEditor.StatusQueryOptions>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string arg1 = null;
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 3);
				bool o = UnityEditor.AssetDatabase.IsOpenForEdit(arg0, out arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.IsOpenForEdit");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int MakeEditable(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				bool o = UnityEditor.AssetDatabase.MakeEditable(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<string[]>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				bool o = UnityEditor.AssetDatabase.MakeEditable(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2)
			{
				string[] arg0 = ToLua.CheckStringArray(L, 1);
				string arg1 = ToLua.CheckString(L, 2);
				bool o = UnityEditor.AssetDatabase.MakeEditable(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 3)
			{
				string[] arg0 = ToLua.CheckStringArray(L, 1);
				string arg1 = ToLua.CheckString(L, 2);
				System.Collections.Generic.List<string> arg2 = (System.Collections.Generic.List<string>)ToLua.CheckObject(L, 3, typeof(System.Collections.Generic.List<string>));
				bool o = UnityEditor.AssetDatabase.MakeEditable(arg0, arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.MakeEditable");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FindAssets(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1)
			{
				string arg0 = ToLua.CheckString(L, 1);
				string[] o = UnityEditor.AssetDatabase.FindAssets(arg0);
				ToLua.Push(L, o);
				return 1;
			}
			else if (count == 2)
			{
				string arg0 = ToLua.CheckString(L, 1);
				string[] arg1 = ToLua.CheckStringArray(L, 2);
				string[] o = UnityEditor.AssetDatabase.FindAssets(arg0, arg1);
				ToLua.Push(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.FindAssets");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int Contains(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				bool o = UnityEditor.AssetDatabase.Contains(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.Contains(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.Contains");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int CreateFolder(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			string o = UnityEditor.AssetDatabase.CreateFolder(arg0, arg1);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsMainAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				bool o = UnityEditor.AssetDatabase.IsMainAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.IsMainAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.IsMainAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsSubAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				bool o = UnityEditor.AssetDatabase.IsSubAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.IsSubAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.IsSubAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsForeignAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				bool o = UnityEditor.AssetDatabase.IsForeignAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.IsForeignAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.IsForeignAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsNativeAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				bool o = UnityEditor.AssetDatabase.IsNativeAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.IsNativeAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.IsNativeAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCurrentCacheServerIp(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			string o = UnityEditor.AssetDatabase.GetCurrentCacheServerIp();
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GenerateUniqueAssetPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string o = UnityEditor.AssetDatabase.GenerateUniqueAssetPath(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int StartAssetEditing(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.StartAssetEditing();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int StopAssetEditing(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.StopAssetEditing();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ReleaseCachedFileHandles(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.ReleaseCachedFileHandles();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ValidateMoveAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			string o = UnityEditor.AssetDatabase.ValidateMoveAsset(arg0, arg1);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int MoveAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			string o = UnityEditor.AssetDatabase.MoveAsset(arg0, arg1);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ExtractAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			string o = UnityEditor.AssetDatabase.ExtractAsset(arg0, arg1);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int RenameAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			string o = UnityEditor.AssetDatabase.RenameAsset(arg0, arg1);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int MoveAssetToTrash(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			bool o = UnityEditor.AssetDatabase.MoveAssetToTrash(arg0);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int MoveAssetsToTrash(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string[] arg0 = ToLua.CheckStringArray(L, 1);
			System.Collections.Generic.List<string> arg1 = (System.Collections.Generic.List<string>)ToLua.CheckObject(L, 2, typeof(System.Collections.Generic.List<string>));
			bool o = UnityEditor.AssetDatabase.MoveAssetsToTrash(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int DeleteAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			bool o = UnityEditor.AssetDatabase.DeleteAsset(arg0);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int DeleteAssets(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string[] arg0 = ToLua.CheckStringArray(L, 1);
			System.Collections.Generic.List<string> arg1 = (System.Collections.Generic.List<string>)ToLua.CheckObject(L, 2, typeof(System.Collections.Generic.List<string>));
			bool o = UnityEditor.AssetDatabase.DeleteAssets(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ImportAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1)
			{
				string arg0 = ToLua.CheckString(L, 1);
				UnityEditor.AssetDatabase.ImportAsset(arg0);
				return 0;
			}
			else if (count == 2)
			{
				string arg0 = ToLua.CheckString(L, 1);
				UnityEditor.ImportAssetOptions arg1 = (UnityEditor.ImportAssetOptions)ToLua.CheckObject(L, 2, typeof(UnityEditor.ImportAssetOptions));
				UnityEditor.AssetDatabase.ImportAsset(arg0, arg1);
				return 0;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.ImportAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int CopyAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			bool o = UnityEditor.AssetDatabase.CopyAsset(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int WriteImportSettingsIfDirty(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			bool o = UnityEditor.AssetDatabase.WriteImportSettingsIfDirty(arg0);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetSubFolders(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string[] o = UnityEditor.AssetDatabase.GetSubFolders(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsValidFolder(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			bool o = UnityEditor.AssetDatabase.IsValidFolder(arg0);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int CreateAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			UnityEditor.AssetDatabase.CreateAsset(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int AddObjectToAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 2 && TypeChecker.CheckTypes<string>(L, 2))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
				string arg1 = ToLua.ToString(L, 2);
				UnityEditor.AssetDatabase.AddObjectToAsset(arg0, arg1);
				return 0;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 2))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
				UnityEngine.Object arg1 = (UnityEngine.Object)ToLua.ToObject(L, 2);
				UnityEditor.AssetDatabase.AddObjectToAsset(arg0, arg1);
				return 0;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.AddObjectToAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int SetMainObject(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			UnityEditor.AssetDatabase.SetMainObject(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetPath(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				string o = UnityEditor.AssetDatabase.GetAssetPath(arg0);
				LuaDLL.lua_pushstring(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string o = UnityEditor.AssetDatabase.GetAssetPath(arg0);
				LuaDLL.lua_pushstring(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.GetAssetPath");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetOrScenePath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			string o = UnityEditor.AssetDatabase.GetAssetOrScenePath(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetTextMetaFilePathFromAssetPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string o = UnityEditor.AssetDatabase.GetTextMetaFilePathFromAssetPath(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetPathFromTextMetaFilePath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string o = UnityEditor.AssetDatabase.GetAssetPathFromTextMetaFilePath(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int LoadAssetAtPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			System.Type arg1 = ToLua.CheckMonoType(L, 2);
			UnityEngine.Object o = UnityEditor.AssetDatabase.LoadAssetAtPath(arg0, arg1);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int LoadMainAssetAtPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEngine.Object o = UnityEditor.AssetDatabase.LoadMainAssetAtPath(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetMainAssetTypeAtPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			System.Type o = UnityEditor.AssetDatabase.GetMainAssetTypeAtPath(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetTypeFromPathAndFileID(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			long arg1 = LuaDLL.tolua_checkint64(L, 2);
			System.Type o = UnityEditor.AssetDatabase.GetTypeFromPathAndFileID(arg0, arg1);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsMainAssetAtPathLoaded(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			bool o = UnityEditor.AssetDatabase.IsMainAssetAtPathLoaded(arg0);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int LoadAllAssetRepresentationsAtPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEngine.Object[] o = UnityEditor.AssetDatabase.LoadAllAssetRepresentationsAtPath(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int LoadAllAssetsAtPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEngine.Object[] o = UnityEditor.AssetDatabase.LoadAllAssetsAtPath(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAllAssetPaths(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			string[] o = UnityEditor.AssetDatabase.GetAllAssetPaths();
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int Refresh(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 0)
			{
				UnityEditor.AssetDatabase.Refresh();
				return 0;
			}
			else if (count == 1)
			{
				UnityEditor.ImportAssetOptions arg0 = (UnityEditor.ImportAssetOptions)ToLua.CheckObject(L, 1, typeof(UnityEditor.ImportAssetOptions));
				UnityEditor.AssetDatabase.Refresh(arg0);
				return 0;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.Refresh");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int OpenAsset(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object[]>(L, 1))
			{
				UnityEngine.Object[] arg0 = ToLua.ToObjectArray<UnityEngine.Object>(L, 1);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<int, int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				int arg1 = (int)LuaDLL.lua_tonumber(L, 2);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEngine.Object, int>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				int arg1 = (int)LuaDLL.lua_tonumber(L, 2);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 3 && TypeChecker.CheckTypes<int, int, int>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				int arg1 = (int)LuaDLL.lua_tonumber(L, 2);
				int arg2 = (int)LuaDLL.lua_tonumber(L, 3);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0, arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 3 && TypeChecker.CheckTypes<UnityEngine.Object, int, int>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				int arg1 = (int)LuaDLL.lua_tonumber(L, 2);
				int arg2 = (int)LuaDLL.lua_tonumber(L, 3);
				bool o = UnityEditor.AssetDatabase.OpenAsset(arg0, arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.OpenAsset");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GUIDToAssetPath(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string o = UnityEditor.AssetDatabase.GUIDToAssetPath(arg0);
				LuaDLL.lua_pushstring(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEditor.GUID>(L, 1))
			{
				UnityEditor.GUID arg0 = StackTraits<UnityEditor.GUID>.To(L, 1);
				string o = UnityEditor.AssetDatabase.GUIDToAssetPath(arg0);
				LuaDLL.lua_pushstring(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.GUIDToAssetPath");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GUIDFromAssetPath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEditor.GUID o = UnityEditor.AssetDatabase.GUIDFromAssetPath(arg0);
			ToLua.PushValue(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int AssetPathToGUID(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string o = UnityEditor.AssetDatabase.AssetPathToGUID(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetDependencyHash(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<UnityEditor.GUID>(L, 1))
			{
				UnityEditor.GUID arg0 = StackTraits<UnityEditor.GUID>.To(L, 1);
				UnityEngine.Hash128 o = UnityEditor.AssetDatabase.GetAssetDependencyHash(arg0);
				ToLua.PushValue(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				UnityEngine.Hash128 o = UnityEditor.AssetDatabase.GetAssetDependencyHash(arg0);
				ToLua.PushValue(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.GetAssetDependencyHash");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int SaveAssets(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.SaveAssets();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCachedIcon(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEngine.Texture o = UnityEditor.AssetDatabase.GetCachedIcon(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int SetLabels(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			string[] arg1 = ToLua.CheckStringArray(L, 2);
			UnityEditor.AssetDatabase.SetLabels(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetLabels(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<UnityEditor.GUID>(L, 1))
			{
				UnityEditor.GUID arg0 = StackTraits<UnityEditor.GUID>.To(L, 1);
				string[] o = UnityEditor.AssetDatabase.GetLabels(arg0);
				ToLua.Push(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<UnityEngine.Object>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string[] o = UnityEditor.AssetDatabase.GetLabels(arg0);
				ToLua.Push(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.GetLabels");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ClearLabels(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			UnityEditor.AssetDatabase.ClearLabels(arg0);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAllAssetBundleNames(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			string[] o = UnityEditor.AssetDatabase.GetAllAssetBundleNames();
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetUnusedAssetBundleNames(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			string[] o = UnityEditor.AssetDatabase.GetUnusedAssetBundleNames();
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int RemoveAssetBundleName(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			bool arg1 = LuaDLL.luaL_checkboolean(L, 2);
			bool o = UnityEditor.AssetDatabase.RemoveAssetBundleName(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int RemoveUnusedAssetBundleNames(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.RemoveUnusedAssetBundleNames();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetPathsFromAssetBundle(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string[] o = UnityEditor.AssetDatabase.GetAssetPathsFromAssetBundle(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetPathsFromAssetBundleAndAssetName(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			string[] o = UnityEditor.AssetDatabase.GetAssetPathsFromAssetBundleAndAssetName(arg0, arg1);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetImplicitAssetBundleName(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string o = UnityEditor.AssetDatabase.GetImplicitAssetBundleName(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetImplicitAssetBundleVariantName(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			string o = UnityEditor.AssetDatabase.GetImplicitAssetBundleVariantName(arg0);
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAssetBundleDependencies(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			bool arg1 = LuaDLL.luaL_checkboolean(L, 2);
			string[] o = UnityEditor.AssetDatabase.GetAssetBundleDependencies(arg0, arg1);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetDependencies(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1 && TypeChecker.CheckTypes<string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string[] o = UnityEditor.AssetDatabase.GetDependencies(arg0);
				ToLua.Push(L, o);
				return 1;
			}
			else if (count == 1 && TypeChecker.CheckTypes<string[]>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				string[] o = UnityEditor.AssetDatabase.GetDependencies(arg0);
				ToLua.Push(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string, bool>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				bool arg1 = LuaDLL.lua_toboolean(L, 2);
				string[] o = UnityEditor.AssetDatabase.GetDependencies(arg0, arg1);
				ToLua.Push(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string[], bool>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				bool arg1 = LuaDLL.lua_toboolean(L, 2);
				string[] o = UnityEditor.AssetDatabase.GetDependencies(arg0, arg1);
				ToLua.Push(L, o);
				return 1;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.GetDependencies");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ExportPackage(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 2 && TypeChecker.CheckTypes<string, string>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string arg1 = ToLua.ToString(L, 2);
				UnityEditor.AssetDatabase.ExportPackage(arg0, arg1);
				return 0;
			}
			else if (count == 2 && TypeChecker.CheckTypes<string[], string>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				string arg1 = ToLua.ToString(L, 2);
				UnityEditor.AssetDatabase.ExportPackage(arg0, arg1);
				return 0;
			}
			else if (count == 3 && TypeChecker.CheckTypes<string, string, UnityEditor.ExportPackageOptions>(L, 1))
			{
				string arg0 = ToLua.ToString(L, 1);
				string arg1 = ToLua.ToString(L, 2);
				UnityEditor.ExportPackageOptions arg2 = (UnityEditor.ExportPackageOptions)ToLua.ToObject(L, 3);
				UnityEditor.AssetDatabase.ExportPackage(arg0, arg1, arg2);
				return 0;
			}
			else if (count == 3 && TypeChecker.CheckTypes<string[], string, UnityEditor.ExportPackageOptions>(L, 1))
			{
				string[] arg0 = ToLua.ToStringArray(L, 1);
				string arg1 = ToLua.ToString(L, 2);
				UnityEditor.ExportPackageOptions arg2 = (UnityEditor.ExportPackageOptions)ToLua.ToObject(L, 3);
				UnityEditor.AssetDatabase.ExportPackage(arg0, arg1, arg2);
				return 0;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.ExportPackage");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsMetaFileOpenForEdit(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 1)
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
				bool o = UnityEditor.AssetDatabase.IsMetaFileOpenForEdit(arg0);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<UnityEditor.StatusQueryOptions>(L, 2))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
				UnityEditor.StatusQueryOptions arg1 = (UnityEditor.StatusQueryOptions)ToLua.ToObject(L, 2);
				bool o = UnityEditor.AssetDatabase.IsMetaFileOpenForEdit(arg0, arg1);
				LuaDLL.lua_pushboolean(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes<LuaInterface.LuaOut<string>>(L, 2))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
				string arg1 = null;
				bool o = UnityEditor.AssetDatabase.IsMetaFileOpenForEdit(arg0, out arg1);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else if (count == 3)
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
				string arg1 = null;
				UnityEditor.StatusQueryOptions arg2 = (UnityEditor.StatusQueryOptions)ToLua.CheckObject(L, 3, typeof(UnityEditor.StatusQueryOptions));
				bool o = UnityEditor.AssetDatabase.IsMetaFileOpenForEdit(arg0, out arg1, arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				return 2;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.IsMetaFileOpenForEdit");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetBuiltinExtraResource(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			System.Type arg0 = ToLua.CheckMonoType(L, 1);
			string arg1 = ToLua.CheckString(L, 2);
			UnityEngine.Object o = UnityEditor.AssetDatabase.GetBuiltinExtraResource(arg0, arg1);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ForceReserializeAssets(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 0)
			{
				UnityEditor.AssetDatabase.ForceReserializeAssets();
				return 0;
			}
			else if (count == 1)
			{
				System.Collections.Generic.IEnumerable<string> arg0 = (System.Collections.Generic.IEnumerable<string>)ToLua.CheckObject<System.Collections.Generic.IEnumerable<string>>(L, 1);
				UnityEditor.AssetDatabase.ForceReserializeAssets(arg0);
				return 0;
			}
			else if (count == 2)
			{
				System.Collections.Generic.IEnumerable<string> arg0 = (System.Collections.Generic.IEnumerable<string>)ToLua.CheckObject<System.Collections.Generic.IEnumerable<string>>(L, 1);
				UnityEditor.ForceReserializeAssetsOptions arg1 = (UnityEditor.ForceReserializeAssetsOptions)ToLua.CheckObject(L, 2, typeof(UnityEditor.ForceReserializeAssetsOptions));
				UnityEditor.AssetDatabase.ForceReserializeAssets(arg0, arg1);
				return 0;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.ForceReserializeAssets");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int TryGetGUIDAndLocalFileIdentifier(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 3 && TypeChecker.CheckTypes<int, LuaInterface.LuaOut<string>, LuaInterface.LuaOut<long>>(L, 1))
			{
				int arg0 = (int)LuaDLL.lua_tonumber(L, 1);
				string arg1 = null;
				long arg2;
				bool o = UnityEditor.AssetDatabase.TryGetGUIDAndLocalFileIdentifier(arg0, out arg1, out arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				LuaDLL.tolua_pushint64(L, arg2);
				return 3;
			}
			else if (count == 3 && TypeChecker.CheckTypes<UnityEngine.Object, LuaInterface.LuaOut<string>, LuaInterface.LuaOut<long>>(L, 1))
			{
				UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.ToObject(L, 1);
				string arg1 = null;
				long arg2;
				bool o = UnityEditor.AssetDatabase.TryGetGUIDAndLocalFileIdentifier(arg0, out arg1, out arg2);
				LuaDLL.lua_pushboolean(L, o);
				LuaDLL.lua_pushstring(L, arg1);
				LuaDLL.tolua_pushint64(L, arg2);
				return 3;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: UnityEditor.AssetDatabase.TryGetGUIDAndLocalFileIdentifier");
			}
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int RemoveObjectFromAsset(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			UnityEngine.Object arg0 = (UnityEngine.Object)ToLua.CheckObject<UnityEngine.Object>(L, 1);
			UnityEditor.AssetDatabase.RemoveObjectFromAsset(arg0);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ImportPackage(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			bool arg1 = LuaDLL.luaL_checkboolean(L, 2);
			UnityEditor.AssetDatabase.ImportPackage(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int DisallowAutoRefresh(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.DisallowAutoRefresh();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int AllowAutoRefresh(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.AllowAutoRefresh();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ClearImporterOverride(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEditor.AssetDatabase.ClearImporterOverride(arg0);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsCacheServerEnabled(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			bool o = UnityEditor.AssetDatabase.IsCacheServerEnabled();
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetImporterOverride(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			System.Type o = UnityEditor.AssetDatabase.GetImporterOverride(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetAvailableImporterTypes(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			System.Type[] o = UnityEditor.AssetDatabase.GetAvailableImporterTypes(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int CanConnectToCacheServer(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			ushort arg1 = (ushort)LuaDLL.luaL_checknumber(L, 2);
			bool o = UnityEditor.AssetDatabase.CanConnectToCacheServer(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int RefreshSettings(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.RefreshSettings();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsConnectedToCacheServer(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			bool o = UnityEditor.AssetDatabase.IsConnectedToCacheServer();
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int ResetCacheServerReconnectTimer(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.ResetCacheServerReconnectTimer();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int CloseCacheServerConnection(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			UnityEditor.AssetDatabase.CloseCacheServerConnection();
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCacheServerAddress(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			string o = UnityEditor.AssetDatabase.GetCacheServerAddress();
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCacheServerPort(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			ushort o = UnityEditor.AssetDatabase.GetCacheServerPort();
			LuaDLL.lua_pushnumber(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCacheServerNamespacePrefix(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			string o = UnityEditor.AssetDatabase.GetCacheServerNamespacePrefix();
			LuaDLL.lua_pushstring(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCacheServerEnableDownload(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			bool o = UnityEditor.AssetDatabase.GetCacheServerEnableDownload();
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int GetCacheServerEnableUpload(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			bool o = UnityEditor.AssetDatabase.GetCacheServerEnableUpload();
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsDirectoryMonitoringEnabled(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			bool o = UnityEditor.AssetDatabase.IsDirectoryMonitoringEnabled();
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int RegisterCustomDependency(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			string arg0 = ToLua.CheckString(L, 1);
			UnityEngine.Hash128 arg1 = StackTraits<UnityEngine.Hash128>.Check(L, 2);
			UnityEditor.AssetDatabase.RegisterCustomDependency(arg0, arg1);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int UnregisterCustomDependencyPrefixFilter(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			string arg0 = ToLua.CheckString(L, 1);
			uint o = UnityEditor.AssetDatabase.UnregisterCustomDependencyPrefixFilter(arg0);
			LuaDLL.lua_pushnumber(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int IsAssetImportWorkerProcess(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 0);
			bool o = UnityEditor.AssetDatabase.IsAssetImportWorkerProcess();
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_onImportPackageItemsCompleted(IntPtr L)
	{
		try
		{
			ToLua.Push(L, UnityEditor.AssetDatabase.onImportPackageItemsCompleted);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_GlobalArtifactDependencyVersion(IntPtr L)
	{
		try
		{
			LuaDLL.lua_pushnumber(L, UnityEditor.AssetDatabase.GlobalArtifactDependencyVersion);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_GlobalArtifactProcessedVersion(IntPtr L)
	{
		try
		{
			LuaDLL.lua_pushnumber(L, UnityEditor.AssetDatabase.GlobalArtifactProcessedVersion);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_importPackageStarted(IntPtr L)
	{
		ToLua.Push(L, new EventObject(typeof(UnityEditor.AssetDatabase.ImportPackageCallback)));
		return 1;
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_importPackageCompleted(IntPtr L)
	{
		ToLua.Push(L, new EventObject(typeof(UnityEditor.AssetDatabase.ImportPackageCallback)));
		return 1;
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_importPackageCancelled(IntPtr L)
	{
		ToLua.Push(L, new EventObject(typeof(UnityEditor.AssetDatabase.ImportPackageCallback)));
		return 1;
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_importPackageFailed(IntPtr L)
	{
		ToLua.Push(L, new EventObject(typeof(UnityEditor.AssetDatabase.ImportPackageFailedCallback)));
		return 1;
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int get_cacheServerConnectionChanged(IntPtr L)
	{
		ToLua.Push(L, new EventObject(typeof(System.Action<UnityEditor.CacheServerConnectionChangedParameters>)));
		return 1;
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int set_onImportPackageItemsCompleted(IntPtr L)
	{
		try
		{
			System.Action<string[]> arg0 = (System.Action<string[]>)ToLua.CheckDelegate<System.Action<string[]>>(L, 2);
			UnityEditor.AssetDatabase.onImportPackageItemsCompleted = arg0;
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int set_importPackageStarted(IntPtr L)
	{
		try
		{
			EventObject arg0 = null;

			if (LuaDLL.lua_isuserdata(L, 2) != 0)
			{
				arg0 = (EventObject)ToLua.ToObject(L, 2);
			}
			else
			{
				return LuaDLL.luaL_throw(L, "The event 'UnityEditor.AssetDatabase.importPackageStarted' can only appear on the left hand side of += or -= when used outside of the type 'UnityEditor.AssetDatabase'");
			}

			if (arg0.op == EventOp.Add)
			{
				UnityEditor.AssetDatabase.ImportPackageCallback ev = (UnityEditor.AssetDatabase.ImportPackageCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageStarted += ev;
			}
			else if (arg0.op == EventOp.Sub)
			{
				UnityEditor.AssetDatabase.ImportPackageCallback ev = (UnityEditor.AssetDatabase.ImportPackageCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageStarted -= ev;
			}

			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int set_importPackageCompleted(IntPtr L)
	{
		try
		{
			EventObject arg0 = null;

			if (LuaDLL.lua_isuserdata(L, 2) != 0)
			{
				arg0 = (EventObject)ToLua.ToObject(L, 2);
			}
			else
			{
				return LuaDLL.luaL_throw(L, "The event 'UnityEditor.AssetDatabase.importPackageCompleted' can only appear on the left hand side of += or -= when used outside of the type 'UnityEditor.AssetDatabase'");
			}

			if (arg0.op == EventOp.Add)
			{
				UnityEditor.AssetDatabase.ImportPackageCallback ev = (UnityEditor.AssetDatabase.ImportPackageCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageCompleted += ev;
			}
			else if (arg0.op == EventOp.Sub)
			{
				UnityEditor.AssetDatabase.ImportPackageCallback ev = (UnityEditor.AssetDatabase.ImportPackageCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageCompleted -= ev;
			}

			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int set_importPackageCancelled(IntPtr L)
	{
		try
		{
			EventObject arg0 = null;

			if (LuaDLL.lua_isuserdata(L, 2) != 0)
			{
				arg0 = (EventObject)ToLua.ToObject(L, 2);
			}
			else
			{
				return LuaDLL.luaL_throw(L, "The event 'UnityEditor.AssetDatabase.importPackageCancelled' can only appear on the left hand side of += or -= when used outside of the type 'UnityEditor.AssetDatabase'");
			}

			if (arg0.op == EventOp.Add)
			{
				UnityEditor.AssetDatabase.ImportPackageCallback ev = (UnityEditor.AssetDatabase.ImportPackageCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageCancelled += ev;
			}
			else if (arg0.op == EventOp.Sub)
			{
				UnityEditor.AssetDatabase.ImportPackageCallback ev = (UnityEditor.AssetDatabase.ImportPackageCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageCancelled -= ev;
			}

			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int set_importPackageFailed(IntPtr L)
	{
		try
		{
			EventObject arg0 = null;

			if (LuaDLL.lua_isuserdata(L, 2) != 0)
			{
				arg0 = (EventObject)ToLua.ToObject(L, 2);
			}
			else
			{
				return LuaDLL.luaL_throw(L, "The event 'UnityEditor.AssetDatabase.importPackageFailed' can only appear on the left hand side of += or -= when used outside of the type 'UnityEditor.AssetDatabase'");
			}

			if (arg0.op == EventOp.Add)
			{
				UnityEditor.AssetDatabase.ImportPackageFailedCallback ev = (UnityEditor.AssetDatabase.ImportPackageFailedCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageFailed += ev;
			}
			else if (arg0.op == EventOp.Sub)
			{
				UnityEditor.AssetDatabase.ImportPackageFailedCallback ev = (UnityEditor.AssetDatabase.ImportPackageFailedCallback)arg0.func;
				UnityEditor.AssetDatabase.importPackageFailed -= ev;
			}

			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int set_cacheServerConnectionChanged(IntPtr L)
	{
		try
		{
			EventObject arg0 = null;

			if (LuaDLL.lua_isuserdata(L, 2) != 0)
			{
				arg0 = (EventObject)ToLua.ToObject(L, 2);
			}
			else
			{
				return LuaDLL.luaL_throw(L, "The event 'UnityEditor.AssetDatabase.cacheServerConnectionChanged' can only appear on the left hand side of += or -= when used outside of the type 'UnityEditor.AssetDatabase'");
			}

			if (arg0.op == EventOp.Add)
			{
				System.Action<UnityEditor.CacheServerConnectionChangedParameters> ev = (System.Action<UnityEditor.CacheServerConnectionChangedParameters>)arg0.func;
				UnityEditor.AssetDatabase.cacheServerConnectionChanged += ev;
			}
			else if (arg0.op == EventOp.Sub)
			{
				System.Action<UnityEditor.CacheServerConnectionChangedParameters> ev = (System.Action<UnityEditor.CacheServerConnectionChangedParameters>)arg0.func;
				UnityEditor.AssetDatabase.cacheServerConnectionChanged -= ev;
			}

			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int UnityEditor_AssetDatabase_ImportPackageFailedCallback(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);
			LuaFunction func = ToLua.CheckLuaFunction(L, 1);

			if (count == 1)
			{
				Delegate arg1 = DelegateTraits<UnityEditor.AssetDatabase.ImportPackageFailedCallback>.Create(func);
				ToLua.Push(L, arg1);
			}
			else
			{
				LuaTable self = ToLua.CheckLuaTable(L, 2);
				Delegate arg1 = DelegateTraits<UnityEditor.AssetDatabase.ImportPackageFailedCallback>.Create(func, self);
				ToLua.Push(L, arg1);
			}
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int UnityEditor_AssetDatabase_ImportPackageCallback(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);
			LuaFunction func = ToLua.CheckLuaFunction(L, 1);

			if (count == 1)
			{
				Delegate arg1 = DelegateTraits<UnityEditor.AssetDatabase.ImportPackageCallback>.Create(func);
				ToLua.Push(L, arg1);
			}
			else
			{
				LuaTable self = ToLua.CheckLuaTable(L, 2);
				Delegate arg1 = DelegateTraits<UnityEditor.AssetDatabase.ImportPackageCallback>.Create(func, self);
				ToLua.Push(L, arg1);
			}
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}
}
#endif